/*
 * @nevware21/ts-async
 * https://github.com/nevware21/ts-async
 *
 * Copyright (c) 2022 Nevware21
 * Licensed under the MIT license.
 */
import { createAsyncAllPromise, createAsyncRejectedPromise, createAsyncResolvedPromise } from "./promise/asyncPromise";
import { objForEachKey } from "@nevware21/ts-utils";
import { PolyPromise } from "./polyfills/promise";
(function () {
    var promisePolyfills = {
        "all": createAsyncAllPromise,
        "resolved": createAsyncResolvedPromise,
        "rejected": createAsyncRejectedPromise
    };
    if (!Promise) {
        Promise = PolyPromise;
    }
    else {
        // Add Object polyfills
        var PromiseClass_1 = Promise;
        if (PromiseClass_1) {
            objForEachKey(promisePolyfills, function (key, value) {
                if (!PromiseClass_1[key]) {
                    PromiseClass_1[key] = value;
                }
            });
        }
    }
})();
//# sourceMappingURL=polyfills.js.map