import { createAsyncAllPromise, createAsyncRejectedPromise, createAsyncResolvedPromise } from "./promise/asyncPromise";
import { objForEachKey } from "@nevware21/ts-utils";
import { PolyPromise } from "./polyfills/promise";
(function () {
    const promisePolyfills = {
        "all": createAsyncAllPromise,
        "resolved": createAsyncResolvedPromise,
        "rejected": createAsyncRejectedPromise
    };
    if (!Promise) {
        Promise = PolyPromise;
    }
    else {
        let PromiseClass = Promise;
        if (PromiseClass) {
            objForEachKey(promisePolyfills, (key, value) => {
                if (!PromiseClass[key]) {
                    PromiseClass[key] = value;
                }
            });
        }
    }
})();
//# sourceMappingURL=polyfills.js.map