import { isUndefined } from "@nevware21/ts-utils";
import { _createAllPromise, _createPromise, _createRejectedPromise, _createResolvedPromise } from "./base";
import { idleItemProcessor } from "./itemProcessor";
let _defaultIdleTimeout;
export function setDetaultIdleTimeout(idleDeadline) {
    _defaultIdleTimeout = idleDeadline;
}
export function createIdlePromise(executor, timeout) {
    let theTimeout = isUndefined(timeout) ? _defaultIdleTimeout : timeout;
    return _createPromise(createIdlePromise, idleItemProcessor(theTimeout), executor, theTimeout);
}
export const createIdleAllPromise = _createAllPromise(createIdlePromise);
export const createIdleResolvedPromise = _createResolvedPromise(createIdlePromise);
export const createIdleRejectedPromise = _createRejectedPromise(createIdlePromise);
//# sourceMappingURL=idlePromise.js.map